﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using ReaderA;


namespace DL730PLUS
{
    public partial class Form1 : Form
    {
        private const byte lengthError = 0x01;
        private const byte operationNotSupport = 0x02;
        private const byte dataRangError = 0x03;
        private const byte cmdNotOperation = 0x04;
        private const byte rfClosed = 0x05;
        private const byte EEPROM = 0x06;
        private const byte timeOut = 0x0a;
        private const byte moreUID = 0x0b;
        private const byte ISOError = 0x0c;
        private const byte noElectronicTag = 0x0e;
        private const byte operationError = 0x0f;
        private const byte cmdNotSupport = 0x01;
        private const byte cmdNotIdentify = 0x02;
        private const byte errOperationNotSupport = 0x03;
        private const byte unknownError = 0x0f;
        private const byte blockError = 0x10;
        private const byte blockLockedCntLock = 0x11;
        private const byte blockLockedCntWrite = 0x12;
        private const byte blockCntOperate = 0x13;
        private const byte blockCntLock = 0x14;
        private const byte communicationErr = 0x30;
        private const byte retCRCErr = 0x31;
        private const byte retDataErr = 0x32;
        private const byte communicationBusy = 0x33;
        private const byte executeCmdBusy = 0x34;
        private const byte comPortOpened = 0x35;
        private const byte comPortClose = 0x36;
        private const byte invalidHandle = 0x37;
        private const byte invalidPort = 0x38;

        private int portIndex = -1;
        private byte readerAddr = 0xff;
        private const byte OK = 0x00;
        private bool fIsAppClose = false;
        private ArrayList AlreadyOpenPortList = new ArrayList();
        public Form1()
        {
            InitializeComponent();
        }

        private string GetUID()
        {
            int fCmdRet = 0x30;
            byte state = 0;
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[9];
            byte cardNumber = 0;
            string strDSFIDAndUID = "";
            for (int count = 0; count < 3; count++)
            {
                fCmdRet = StaticClassReaderA.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portIndex);
                if (fCmdRet == 0)
                {
                    strDSFIDAndUID = ByteArrayToHexString(DSFIDAndUID).Replace(" ", "");
                    return strDSFIDAndUID.Substring(2, 16);
                }
            }
            StatusBar1.Panels[0].Text = DateTime.Now.ToString() + " NO Tags";
            return null;
        }
        private void button2_Click(object sender, EventArgs e)
        {
            if (DataToWrite.Text.Trim() == "")
            {
                DataToWrite.Focus();
                return;
            }
            button2.Enabled = button3.Enabled = false;
            string uid = GetUID();
            if (uid != null)
            {
                byte[] data = System.Text.Encoding.Default.GetBytes(DataToWrite .Text .Trim ());
                if (data.Length == DataToWrite.Text.Length)
                {
                    Writedata(uid, DataToWrite.Text.Trim());
                }
                else
                {
                    MessageBox.Show("Have found illegal character   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    DataToWrite.Focus();
                    DataToWrite.SelectAll();
                }
            }
            button2.Enabled = button3.Enabled = true;
        }
        private void Writedata(string writeUID,string writedata)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            UID = HexStringToByteArray(writeUID);
            blockNum = 0;
            state = 8;
            string cudata = "";
            int lenght = 4;
            bool ok = false;
            for (byte block = 0; block < 2; block++)
            {
                blockNum = block;
                lenght = 4;
                if((block *4+4)>writedata .Length )
                {
                    lenght = 4 + writedata.Length-(block * 4 + 4);
                }
                if (lenght > 0)
                {
                    cudata = writedata.Substring(block * 4, lenght);

                    byte[] data = System.Text.Encoding.Default.GetBytes(cudata);
                    if (data.Length < 4)
                    {
                        Array.Resize(ref data, 4);
                    }
                    ok = false;
                    for (int count = 0; count < 3; count++)
                    {
                        fCmdRet = StaticClassReaderA.WriteSingleBlock(ref readerAddr, ref state, UID, blockNum, data, ref errorCode, portIndex);
                        if (fCmdRet == 0)
                        {
                            ok = true;
                            break;
                        }
                    }
                    if (ok == false) break;
                }
            }
            StatusBar1.Panels[0].Text = DateTime.Now.ToString() + (ok ? " Write success" : "Write Fail");
        }
        private void button3_Click(object sender, EventArgs e)
        {
            button2.Enabled = button3.Enabled = false;
            string uid = GetUID();
            DataToWrite.Text = "";
            if (uid != null)
            {
                string data = ReadData(uid);
                if (data != null)
                {
                    DataToWrite.Text = data;
                }
            }
            button2.Enabled = button3.Enabled = true;
        }
        private string  ReadData(string readuid)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte startBlockNum = 0;
            byte blockCount = 0;
            byte blockSize = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            blockCount = 2; //读取的块数
            blockSize = 4;
            byte[] data = new byte[blockSize * blockCount];
            byte[] blockSecStatus = new byte[blockCount];
            UID = HexStringToByteArray(readuid);
            for (int count = 0; count < 3; count++)
            {
                fCmdRet = StaticClassReaderA.ReadMultipleBlock(ref readerAddr, ref state, UID, startBlockNum, blockCount, blockSecStatus, data, ref errorCode, portIndex);
                if (fCmdRet == 0)
                {
                    StatusBar1.Panels[0].Text = DateTime.Now.ToString() + " Read success";
                    string resulttxt = Encoding.Default.GetString(data);
                    return resulttxt;
                }
            }
            StatusBar1.Panels[0].Text = DateTime.Now.ToString() + " Read Fail";
            return null;
        }
        private void AddCmdLog(string cmdStr, int cmdRet)
        {
            try
            {
                if (!fIsAppClose)
                {
                    StatusBar1.Panels[0].Text = "";
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                cmdStr + ": " +
                                                DL810_00GetReturnCodeDesc(cmdRet);
                }
            }
            finally
            {
                ;
            }
        }
        #region 
        private string DL810_00GetReturnCodeDesc(int cmdRet)
        {
            switch (cmdRet)
            {
                case lengthError:
                    return "Command operand length error";
                case operationNotSupport:
                    return "Command not supported";
                case dataRangError:
                    return "Operation data range error";
                case rfClosed:
                    return "RF field is inactive";
                case EEPROM:
                    return "EEPROM operation error";
                case timeOut:
                    return "Inventory-Scan-Time overflow";
                case moreUID:
                    return "Not all tag's UID are collected before the Inventory-Scan-Time overflow";
                case ISOError:
                    return "ISO error";
                case noElectronicTag:
                    return "No Tags";
                case operationError:
                    return "Operation error";
                case communicationErr:
                    return "Communication Error";
                case retCRCErr:
                    return "CRC checksummat Error";
                case communicationBusy:
                    return "Communication busy";
                case cmdNotOperation:
                    return "CMD can't execute at current";
                case comPortOpened:
                    return "Port Opend";
                case comPortClose:
                    return "Port Already Closed";
                case invalidHandle:
                    return "Invalid PortHandle";
                case invalidPort:
                    return "Invalid ComPort ";
                case OK:
                    return "successfully";
                default:
                    return "";
            }
        }
        #endregion
        private void btnOpenComPort_Click(object sender, EventArgs e)
        {
            int portNum = -1;
            int fCmdRet = 0x30;
            try
            {
                this.Cursor = Cursors.WaitCursor;
                readerAddr = Convert.ToByte("FF", 16);
                fCmdRet = StaticClassReaderA.AutoOpenComPort(ref portNum, ref readerAddr, ref portIndex);
                AddCmdLog(btnOpenComPort.Text, fCmdRet);
                if (fCmdRet == 0)
                {
                    StatusBar1.Panels[1].Text = "COM" + portNum.ToString();
                    panel1.Enabled = true;
                    btnOpenComPort.Enabled = false;
                    btnCloseComPort.Enabled = true;
                }
                else
                {
                    MessageBox.Show("Communication error", "Communication");
                }
            }
            finally
            {
                this.Cursor = Cursors.Arrow;
            }
        }

        private void btnCloseComPort_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            fCmdRet = StaticClassReaderA.CloseSpecComPort(portIndex);
            AddCmdLog(btnCloseComPort.Text, fCmdRet);
            if (fCmdRet == 0)
            {
                panel1.Enabled = false;
                btnOpenComPort.Enabled = true;
                btnCloseComPort.Enabled = false; 
            }
        }
        #region  16进制字符串到数组之间的相互转换
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        #endregion

        private void label1_DoubleClick(object sender, EventArgs e)
        {
            Label label = (Label)sender;
            frmsettxt frm = new frmsettxt();
            frm.textBox1.Text = label.Text;
            if (frm.ShowDialog(this) != DialogResult.OK) return;
            label.Text = frm.textBox1.Text.Trim();
            DataBase.SaveToini("set", label.Name, label.Text);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string tmp = DataBase.GetFromini("set", "label1");
            if (string.IsNullOrEmpty(tmp) == false)
            {
                label1.Text = tmp;
            }
        }
    }
}
