﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;

namespace DL730PDA
{
    public partial class frmmain : Form
    {
        [DllImport("coredll.dll")]
        public static extern bool MessageBeep(int uType);

        string filename = "\\D35FLASH\\DL730PDA\\dan.txt";
        
        private byte readerAddr = 0xFF;
        private int result = 0x30;
        private const byte OK = 0x00;
        private bool Reading = false;

        const int _bianma=1;
        const int _StockQty=2;
        const int _count=3;
        string allTag = "";
        bool Start = false;

        int delaytime = 0;
        bool showti = false;

        private byte[] DSFIDAndUID = new byte[8600];

        public frmmain()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            RWDev.ModulePowerOff();
            RWDev.ModulePowerOn();           
            Connect();
            RWDev.OpenRF(readerAddr);
            RWDev.WriteInventoryScanTime(readerAddr, 5); 
        }
        private void button2_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(filename))
            {
                System.IO.File.Delete(filename);
            }
            listView1.Items.Clear();
            savebtn.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                button1.Enabled = false;
                Start = !Start;
                if (Start)  //盘点
                {
                    label2.Text = "0";
                    allTag = "";
                    if (opendan() == false) return;
                    button1.Text = "Stop";
                    panel2.Enabled = false;
                    Cursor.Hide();
                }
                else //停止
                {
                    button1.Text = "Start";
                    panel2.Enabled = true;
                    Cursor.Show();
                }
                timer1.Enabled = Start;
            }
            finally
            {
                button1.Enabled = true;
            }
        }
        private bool  opendan()
        {
            try
            {
                listView1.Items.Clear();
                if (!System.IO.File.Exists(filename)) return true;
                string line;
                StreamReader file = new StreamReader(filename, System.Text.Encoding.Default);
                Cursor.Current = Cursors.WaitCursor;
                while ((line = file.ReadLine()) != null)
                {
                    ListViewItem item = new ListViewItem((listView1.Items.Count + 1).ToString());
                    item.SubItems.Add(line);
                    item.SubItems.Add("1");
                    item.SubItems.Add("");
                    item.ForeColor = Color.Red;
                    listView1.Items.Add(item);
                }
                file.Close();
                return true;
            }
            catch
            {
                return false;
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private void savebtn_Click(object sender, EventArgs e)
        {
            if (saveit())
            {
                savebtn.Enabled = false;
            }
        }
        private bool saveit()
        {
            try
            {
                if (System.IO.File.Exists(filename)) System.IO.File.Delete(filename);
                Cursor.Current = Cursors.WaitCursor;
                StreamWriter file = new StreamWriter(filename, false, System.Text.Encoding.Unicode);
                string line = null;
                for (int row = 0; row < listView1.Items.Count; row++)
                {
                    if (listView1.Items[row].SubItems[_count].Text != "")
                    {
                        line = listView1.Items[row].SubItems[_bianma].Text;
                        file.WriteLine(line);
                    }
                }
                file.Close();
                return true;
            }
            catch
            {
                return false;
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }
      
        private void  Connect()
        {
            result = RWDev.ConnectReader();
            if (result == OK)
            {
                button1.Enabled = panel2.Enabled = true;
            }
            else
            {
                MessageBox.Show("ConnectReader failed.", "Communication");
            }
            return;
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (showti)
            {
                if ((delaytime++) > 20) //100*20=2000
                {
                    label2.Visible = false;
                    showti = false;
                    delaytime = 0;
                }
            }
            if (Reading) return;
            Reading = true;

            timer1.Enabled = false;
            label1.Text = "";
            byte state = 0x02;
            byte AFI = 0;
            byte CardNum = 0;
            string uidTemp = "", temp = "";
            bool beep = false;
            result = RWDev.Inventory(readerAddr, state, AFI, DSFIDAndUID, ref CardNum);
            if (CardNum > 0)
            {
                showti = true;
                delaytime = 0;
                label2.Visible = true;
                byte[] daw = new byte[9 * (CardNum)];
                Array.Copy(DSFIDAndUID, daw, CardNum * 9);
                uidTemp = ByteArrayToHexString(daw);
                for (int i = 0; i < CardNum; i++)
                {
                    Application.DoEvents();
                    if (Start == false) break;
                    temp = uidTemp.Substring(18 * i + 2, 16);
                    label1.Text = "UID:" + temp;
                    if (allTag.IndexOf(temp + "\t") < 0)
                    {
                        MessageBeep(3);
                        beep = true;
                        if (!check(temp)) break;
                    }
                }
                if (beep==false) MessageBeep(18);
            }
            Reading = false;
            timer1.Enabled = Start;
        }
        private bool  check(string cardno)
        {
            string bianhao = ReadData(cardno);
            if (bianhao == null) return false;
            if (bianhao.IndexOf('\0') == 0) return false;
            label2.Text = (int.Parse(label2.Text) + 1).ToString();
            if (allTag.Length > 65500) allTag = "";
            allTag += cardno + "\t";
            int row = -1;
            foreach (ListViewItem item in listView1.Items)
            {
                if (item.SubItems[_bianma].Text == bianhao)
                {
                    item.SubItems[_count].Text = "1";
                    item.ForeColor = Color.Black;
                    savebtn.Enabled = true;
                    row = item.Index;
                    break ;
                }
            }
            if (row==-1)
            {
                ListViewItem item = new ListViewItem((listView1.Items.Count + 1).ToString());
                item.SubItems.Add(bianhao);
                item.SubItems.Add("0");
                item.SubItems.Add("1");
                item.ForeColor = Color.Green;
                listView1.Items.Add(item);
                savebtn.Enabled = true;
                row = listView1.Items.Count - 1;
            }
            listView1.Items[row].Selected = true;
            listView1.EnsureVisible(row);
            return true;
        }
        private string ReadData(string Cardno)
        {
            this.Text = "Busying";
            byte[] UID = HexStringToByteArray(Cardno);
            Cardno = null;
            byte state = 0, errorCode = 0;
            byte startBlockNum = 0;
            byte blockCount = 2;
            byte[] blockSecStatus = new byte[blockCount];
            byte[] data = new byte[8];
            result = RWDev.ReadMultipleBlock(readerAddr, state, UID, startBlockNum, blockCount, blockSecStatus, data, ref errorCode);
            if (result == 0)
            {
                Cardno = Encoding.Default.GetString(data, 0, data.Length);
            }
            this.Text = "";
            return Cardno;
        }
        //#region
        private void Form1_Closed(object sender, EventArgs e)
        {
            if (RWDev.DisconnectReader() != OK)
            {
                MessageBox.Show("DisconnectReader failed.", "Communication");
            }
        }
        
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();
        }
       // #endregion
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
    }
}